////////////////////////////////////////////////////////////////////////
//Beschleunigung der Rechnungen durch Nutzung aller Cores
//////////////////////////////////////////////////////////////////////
class Threads extends Thread {
  Complex zNeu,zAlt,c,C;
  double xmin,ymin;
  color farbe;
  PGraphics pg;
  int maxiterations;
  int tN;
  int maxN =0; //Kontrolle
  double massFuerUnendlich;
  double wh;
  protected boolean running = false;
  int zaehlen;
  double aQMax =0;
  int farbIndex =0;
  double aQ,laenge;
  boolean julia;
  boolean gJMZeichnen = false;
  boolean mMZeichnen = true;
  color colOrdnung;
  color colChaos;
 // boolean farbTafelErstellt = false;
  //-----------------------------------------
  // Thread anlegen und Parameter übergeben
  //-----------------------------------------
  
  public Threads(double px0, double py0, int pmaxiterations, double pmUnendlich, double pwh, int nummer, double X0, double Y0, boolean Julia) {
    // benötigte Parameter
    tN = nummer; 
    wh = pwh;
    xmin=px0; ymin=py0; 
    maxiterations = pmaxiterations;
    massFuerUnendlich = pmUnendlich; 
    aQ =0;
    C = new Complex(X0,Y0);
    pg = createGraphics(width,height/anzahlThreads);
    julia = Julia;
  }
  
  public int gibNummer(){
   
    return tN;   
  }

 //////////////////////////////////////////////////////////////
  
  public void run() {
    tN =this.gibNummer(); //println(tN);
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;
        //println("x: "+xmin,xmax);//Information
        double ymax = ymin + wh;
        //println(tN,xmax,ymax);//Information
      
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) {  //println(pg.height);
          double x = xmin; //println(x,y);
          for (int i = 0; i < pg.width; i++) {
            c = new Complex(x,y);
            
            if(julia){         
            int m = juliaIteration(c);
            pg.pixels[i+j*pg.width] = colorize(m);
            }else{
             int n = mandelbrotIteration(c);          
            pg.pixels[i+j*pg.width] = colorize(n);
            }         
            x += dx; //if(tN==0 && y==0) println(x);
          }
          y += dy;
        }
       pg.updatePixels();     
    pg.endDraw(); 
   
    this.running = false;
   
  }
/////////////////////////////////////////////////////////////////////
int juliaIteration(Complex Z0) {

  int n = 0;
 
  zAlt = Z0;
  while (n < maxiterations) {
    zNeu = zAlt.multiply(zAlt);
    zNeu = zNeu.addC(C);
    laenge =zNeu.getLength();
    aQ = 3000*laenge;
    if (laenge > massFuerUnendlich) {
      break;  // Bail
    }
   
    zAlt = zNeu;
    n++;
  }
 
  return n;
 }
  
/////////////////////////////////////////////////////////////////////
int mandelbrotIteration(Complex C) {

  int n = 0;
  zAlt = C;
  while (n < maxiterations) {
    zNeu =zAlt.multiply(zAlt);
    zNeu = zNeu.addC(C);
    laenge =zNeu.getLength();
    aQ = 1000*laenge;
    if (laenge > massFuerUnendlich) {
      break;  // Bail
    }
    zAlt = zNeu;
    n++;
  }

  return n;
 }

////////////////////////////////////////////////////////////////////
color colorize(int n) {
  colorMode(RGB);
  if (n == maxiterations){
   if(julia) farbe = color(0);
      else farbe = color(0,0,100);
     return  farbe;
  }else{   
    farbe = color(200);    
    return farbe; 
  }
 }
}
